import bpy

from all_axis_render_camera.panels import CamSetupPanel

from .properties import SetupCamsAddonProperties

from .operators import (
    CamSetupOperator,
    RenderOperator,
    CreateInvisibleTargetOperator,
    SaveRenderingContextOperator,
)
from .setup_cameras import update_camera_setup_depsgraph_handler


classes_to_register = [
    CamSetupPanel,
    CamSetupOperator,
    RenderOperator,
    SaveRenderingContextOperator,
    CreateInvisibleTargetOperator,
]


def register():
    bpy.utils.register_class(SetupCamsAddonProperties)
    bpy.types.Scene.cam_setup = bpy.props.PointerProperty(type=SetupCamsAddonProperties)

    for klass in classes_to_register:
        bpy.utils.register_class(klass)

    bpy.app.handlers.depsgraph_update_post.append(update_camera_setup_depsgraph_handler)


def unregister():

    for klass in classes_to_register:
        bpy.utils.unregister_class(klass)

    del bpy.types.Scene.cam_setup
    bpy.utils.unregister_class(SetupCamsAddonProperties)

    # todo: remove
    bpy.app.handlers.depsgraph_update_post.clear()
