import bpy
from all_axis_render_camera.utils import get_cam_setup
from all_axis_render_camera.setup_cameras import setup_camera_positions


class CamSetupOperator(bpy.types.Operator):
    """Execute the main camera setup"""

    bl_idname = "scene.cam_setup_operator"
    bl_label = "Create Camera"

    def execute(self, context):
        cam_setup_context = get_cam_setup(context)
        setup_camera_positions(
            context,
            cam_setup_context.cam_rows,
            cam_setup_context.cam_columns,
            cam_setup_context.radius,
            cam_setup_context.structure_type,
            cam_setup_context.center_type,
            cam_setup_context.center_object,
        )

        return {"FINISHED"}
