import bpy

from all_axis_render_camera.utils import get_cam_setup


class CamSetupPanel(bpy.types.Panel):
    bl_idname = "OBJECT_PT_all_axis_cam_setup"
    bl_label = "All Axis Render Camera"
    bl_space_type = "PROPERTIES"
    bl_region_type = "WINDOW"
    bl_context = "render"

    def draw(self, context):
        layout = self.layout
        cam_setup_context = get_cam_setup(context)

        # Camera Setup Section
        layout.label(text="Camera Setup")
        box = layout.box()
        box.prop(cam_setup_context, "cam_rows", text="Number of Rows")
        box.prop(cam_setup_context, "cam_columns", text="Number of Columns")
        box.prop(cam_setup_context, "radius", text="Radius")
        box.prop(cam_setup_context, "structure_type", text="Type")
        box.prop(cam_setup_context, "center_type", text="Center Type")
        if cam_setup_context.center_type == "object":
            box.operator("object.create_invisible_target")
            box.prop(cam_setup_context, "center_object", text="Center Object")
            box.prop(
                cam_setup_context, "camera_setup_follows_object", text="Follow Object"
            )
        box.operator("scene.cam_setup_operator")

        # Render Section
        layout.label(text="Render")
        box = layout.box()
        box.prop(context.scene.render, "filepath", text="Output Directory")
        box.operator("scene.render_operator")

        # box.prop(cam_setup_context, "dataset_directory", text="Dataset Directory")
        # box.prop(cam_setup_context, "number_of_points", text="Number of Points")
        box.operator("scene.save_rendering_context")
